SalesforceRestClient::SalesforceRestConnection Class Reference

class for Salesforce.com REST connections; returns SalesforceRestClient::SalesforceRestClient objects More...

Inheritance diagram for SalesforceRestClient::SalesforceRestConnection:
[legend]

## Public Member Functions

| constructor (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| creates the SalesforceRestConnection object More...
*hash | getDefaultOptions ()
| returns default options
hash | getOptions ()
| gets options More...
string | getType ()
| returns `"rest"`

## Static Public Member Functions

static SalesforceRestConnection | make (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| static constructor

## Public Attributes

const | Options
| SalesforceRestConnection object connection options.

## Private Member Functions

SalesforceRestClient | getImpl (bool connect=True, *hash rtopts)
| returns a SalesforceRestClient::SalesforceRestClient object More...

## Detailed Description

class for Salesforce.com REST connections; returns SalesforceRestClient::SalesforceRestClient objects

supports the following options:

- `"api"`: the Salesforce.com API to use; use `"auto"` (the default) to use the latest API version
- `"client_id"`: (required) the Salesforce.com "consumer key" for the Connected App
- `"client_secret"`: (required) the Salesforce.com "consumer secret" for the Connected App
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see DataSerializationOptions for possible values; the default is `"auto"` for possible values; note that it's recommended to use `"yaml"` when talking to Qorus
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"timeout"`: transfer timeout to use in milliseconds

See also
  SalesforceRestClient::constructor() for more information on the above options

Since
  SalesforceRestConnection 1.1

## Member Function Documentation

## constructor()

SalesforceRestClient::SalesforceRestConnection::constructor | ( | string | name,
|  | string | desc,
|  | string | url,
|  | bool | monitor,
|  | *hash | opts,
|  | hash | urlh
| ) |  |

creates the SalesforceRestConnection object

Parameters

  name | the name of the connection
  desc | connection description
  url | connection URL (potentially with password info)
  monitor | monitoring flag
  opts | connection options
  urlh | broken down URL hash (as returned by Qore::parse_url())

## getImpl()

SalesforceRestClient SalesforceRestClient::SalesforceRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash | rtopts
| ) |  |

private virtual

returns a SalesforceRestClient::SalesforceRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a SalesforceRestClient object

Reimplemented from RestClient::RestConnection.

## getOptions()

hash SalesforceRestClient::SalesforceRestConnection::getOptions | ( |  | ) |

gets options

Returns
  returns a hash with the following supported options:
  - `"api"`: the Salesforce.com API to use; use `"auto"` (the default) to use the latest API version
  - `"client_id"`: (required) the Salesforce.com "consumer key" for the Connected App
  - `"client_secret"`: (required) the Salesforce.com "consumer secret" for the Connected App
  - `"connect_timeout"`: connection timeout to use in milliseconds
  - `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
  - `"data"`: see RestClient::RestClient::DataSerializationOptions for possible values; the default is `"auto"` for possible values; note that it's recommended to use `"yaml"` when talking to Qorus
  - `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
  - `"max_redirects"`: maximum redirects to support
  - `"proxy"`: proxy URL to use
  - `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
  - `"timeout"`: transfer timeout to use in milliseconds

See also
  SalesforceRestClient::constructor() for more information on the above options